SoNormal(3)

NAME
SoNormal - The SoNormal class is a node for providing normals to the state.

SYNOPSIS

#include <Inventor/nodes/SoNormal.h>

Inherits SoNode.

  Public Member Functions
virtual SoType getTypeId (void) const
SoNormal (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoMFVec3f vector

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoNormal ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoNormal class is a node for providing normals to the state. Coin will automatically calculate normals for you if no SoNormal nodes are present in the scene graph, but explicitly setting normals is useful for at least two purposes:

1.  a potential increase in performance

2.  you can calculate and use 'incorrect' normals to do various special effects.

FILE FORMAT/DEFAULTS:

Normal {
    vector [  ]
}

See also
    SoNormalBinding

Constructor & Destructor Documentation

  SoNormal::SoNormal (void)
Constructor.

  SoNormal::~SoNormal () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoNormal::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoNormal::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoNormal::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoNormal::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoNormal::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoNormal::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoNormal::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoNormal::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoNormal::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Member Data Documentation

  SoMFVec3f SoNormal::vector
Sets a pool of normal vectors in the traversal state.

Author

Generated automatically by Doxygen for Coin from the source code.